%define	_vararpwatch	%{_localstatedir}/arpwatch
%define PCAP_UID 79
%define PCAP_GID 79

%define releaseno 1.0.6

%define arpwatch_release %{releaseno}
%define pcap_release %{releaseno}
%define tcpdump_release %{releaseno}

Summary: A network traffic monitoring tool.
Name: tcpdump
Version: 3.6.3
%define	tcpdump_dir	tcpdump-3.6.2
%define tcpslice_dir	tcpslice
Release: %{tcpdump_release}
License: BSD
URL: http://www.tcpdump.org
Group: Applications/Internet
Source0: http://www.tcpdump.org/release/tcpdump-3.6.2.tar.gz
Source1: http://www.tcpdump.org/release/libpcap-0.6.2.tar.gz
Source2: ftp://ftp.ee.lbl.gov/arpwatch-2.1a11.tar.gz
Source3: arpwatch.init
Source4: tcpslice-CVS.20010207.tar.gz
Source5: arpwatch.sysconfig
Source6: arpwatch-ethercodes.dat 

Patch5: tcpdump-3.6.2-tcpslice-time.patch
Patch6: tcpdump-3.6.2-usageman.patch
Patch7: tcpdump-3.6.2-redhat.patch
Patch8: tcpdump-3.6.1-droproot2.patch 
Patch9: tcpdump-3.6.1-smb-quiet.patch
Patch10: tcpdump-3.6.1-portnumbers.patch
Patch11: tcpdump-3.6.1-non-promisc-default.patch
Patch12: tcpdump-3.6.2-3.6.3-gd-2.patch
Patch13: tcpdump-3.6.2-dropdefault.patch
Patch14: tcpdump-3.6.2-snaplen.patch
Patch16: tcpdump-3.6.2-bgp.patch
Patch17: tcpdump-3.6.2-radlen.patch
Patch18: tcpdump-3.6.2-isa.patch
Patch19: tcpdump-3.6.2-2.4.patch

Patch34: arpwatch-2.1a4-fhs.patch
Patch35: arpwatch-2.1a10-man.patch
Patch38: arpwatch-drop.patch
Patch39: arpwatch-drop-man.patch
Patch40: arp2ethers.patch
Patch41: arpwatch-addr.patch

Patch50: libpcap-shared.patch
Patch51: tcpdump-3.6.2-purge.patch
Patch52: tcpdump-3.6.2-s390.patch

Patch100: tcpdump-3.6.2-config.patch
Patch101: tcpdump-3.6.3-CAN-2003-0989-gd-2.diff
Patch102: tcpdump-3.6.3-CAN-2003-1029-gd-1.diff

Prefix: %{_prefix}
Requires: kernel >= 2.2.0
BuildRoot: %{_tmppath}/%{name}-%{release}-root

%description
Tcpdump is a command-line tool for monitoring network traffic.
Tcpdump can capture and display the packet headers on a particular
network interface or on all interfaces.  Tcpdump can display all of
the packet headers, or just the ones that match particular criteria.

Install tcpdump if you need a program to monitor network traffic.

%package -n libpcap
Version: 0.6.2
Release: %{pcap_release}
%define	libpcap_dir	libpcap-0.6.2
Summary: A system-independent interface for user-level packet capture.
Group: Development/Libraries
License: BSD
URL: http://www.tcpdump.org
Requires: kernel >= 2.2.0 openssl

%description -n libpcap
Libpcap provides a portable framework for low-level network
monitoring.  Libpcap can provide network statistics collection,
security monitoring and network debugging.  Since almost every system
vendor provides a different interface for packet capture, the libpcap
authors created this system-independent API to ease in porting and to
alleviate the need for several system-dependent packet capture modules
in each application.

Install libpcap if you need to do low-level network traffic monitoring
on your network.

%package -n arpwatch
Version: 2.1a11
Release: %{arpwatch_release}
%define	arpwatch_dir	arpwatch-2.1a11
Summary: Network monitoring tools for tracking IP addresses on a network.
Group: Applications/System
License: BSD
URL: http://www.tcpdump.org
Prereq: /sbin/chkconfig /sbin/service

%description -n arpwatch
The arpwatch package contains arpwatch and arpsnmp.  Arpwatch and
arpsnmp are both network monitoring tools.  Both utilities monitor
Ethernet or FDDI network traffic and build databases of Ethernet/IP
address pairs, and can report certain changes via email.

Install the arpwatch package if you need networking monitoring devices
which will automatically keep track of the IP addresses on your
network.

%prep
%setup -q -c -a 1 -a 2 -a 4

%patch5 -p1 -b .tcpslicetime
%patch7 -p0 -b .rh

pushd %libpcap_dir
%patch50 -p1 -b .shared 
%patch51 -p1 -b .purge
%patch52 -p1 -b .s390
popd

pushd %tcpdump_dir
%patch6 -p1 -b .usageman
%patch8 -p1 -b .droproot
%patch9 -p1 -b .smb
%patch10 -p1 -b .portnumbers
#%patch11 -p1 -b .nonpromisc		# Not by default
%patch12 -p1 -b .afsprinting
%patch13 -p1 -b .dropdefault
%patch14 -p1 -b .snaplen
#%patch16 -p2 -b .bgp
%patch17 -p1 -b .radlen
#%patch18 -p1 -b .isa
%patch19 -p1 -b .deb
popd

pushd %arpwatch_dir
%patch34 -p1 -b .fhs
%patch35 -p1 -b .arpsnmpman
%patch38 -p1 -b .droproot
%patch39 -p0 -b .droprootman
%patch40 -p1 -b .cshpatch
%patch41 -p1 -b .mailuser
chmod u+w ethercodes.dat
cp %SOURCE6 ethercodes.dat
popd


%patch100 -p0 
%patch101 -p1
%patch102 -p1

%build
pushd %libpcap_dir

%configure --enable-ipv6

DEFS="-g -fPIC -DHAVE_CONFIG_H"
%ifarch alpha sparc sparc64
DEFS="$DEFS -DHAVE_ETHER_HOSTTON=1 -DLBL_ALIGN=1"
%endif
make DEFS="$DEFS"

popd

pushd %tcpslice_dir
#aclocal
#autoconf
%configure
make
popd

pushd %tcpdump_dir
%define	optflags $RPM_OPT_FLAGS -DIP_MAX_MEMBERSHIPS=20
#autoconf
%configure --enable-ipv6 --with-user=pcap
%undefine optflags

DEFS="-g -DHAVE_CONFIG_H"
%ifarch alpha sparc sparc64
DEFS="$DEFS -DHAVE_ETHER_HOSTTON=1 -DLBL_ALIGN=1 -DHAVE_ETHER_NTOA=1"
%endif
%ifarch sparc sparc64
DEFS="$DEFS -DWORDS_BIGENDIAN"
%endif

make DEFS="$DEFS"
popd

pushd %arpwatch_dir
#aclocal
#autoconf
%configure
make ARPDIR=%{_vararpwatch}
popd

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man{3,8}
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}

pushd %libpcap_dir
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}/net
make DESTDIR=${RPM_BUILD_ROOT} includedir=%{_includedir} install
chmod +x ${RPM_BUILD_ROOT}%{_libdir}/libpcap.so.*
popd

pushd %tcpslice_dir
install -m755 tcpslice ${RPM_BUILD_ROOT}%{_sbindir}
install -m644 tcpslice.1 ${RPM_BUILD_ROOT}%{_mandir}/man8/tcpslice.8
popd

pushd %tcpdump_dir
install -m755 tcpdump ${RPM_BUILD_ROOT}%{_sbindir}
install -m644 tcpdump.1 ${RPM_BUILD_ROOT}%{_mandir}/man8/tcpdump.8
popd

pushd %arpwatch_dir
make DESTDIR=${RPM_BUILD_ROOT} install install-man
mkdir -p ${RPM_BUILD_ROOT}%{_vararpwatch}
for n in arp2ethers arpfetch massagevendor massagevendor-old; do
	install -m755 $n ${RPM_BUILD_ROOT}%{_vararpwatch}
done
for n in *.awk *.dat missingcodes.txt; do
	install -m644 $n ${RPM_BUILD_ROOT}%{_vararpwatch}
done
( cd ${RPM_BUILD_ROOT}
  mkdir -p ./etc/rc.d/init.d
  install -c -m755 $RPM_SOURCE_DIR/arpwatch.init ./etc/rc.d/init.d/arpwatch
  mkdir -p ./etc/sysconfig
  install -c -m644 $RPM_SOURCE_DIR/arpwatch.sysconfig ./etc/sysconfig/arpwatch
)
popd

( cd ${RPM_BUILD_ROOT}
  strip .%{_sbindir}/* || :
)

%clean
rm -rf ${RPM_BUILD_ROOT}

%pre
/usr/sbin/groupadd -g %{PCAP_GID} pcap  2> /dev/null || :
/usr/sbin/useradd -u %{PCAP_UID} -g %{PCAP_GID} \
        -s /sbin/nologin -M -r -d %{_vararpwatch} pcap 2> /dev/null || ( /usr/bin/chsh pcap /sbin/nologin 2> /dev/null || : )

%post -n arpwatch
/sbin/chkconfig --add arpwatch

%pre -n arpwatch
/usr/sbin/groupadd -g %{PCAP_GID} pcap  2> /dev/null || :  
/usr/sbin/useradd -u %{PCAP_UID} -g %{PCAP_GID} \
        -s /sbin/nologin -M -r -d %{_vararpwatch} pcap 2> /dev/null || ( /usr/bin/chsh pcap /sbin/nologin 2> /dev/null || : )

%postun -n arpwatch
/sbin/service arpwatch condrestart >/dev/null 2>&1 || :

%preun -n arpwatch
if [ "$1" = "0" ]; then
	/sbin/service arpwatch stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del arpwatch
fi

%post -n libpcap -p /sbin/ldconfig

%postun -n libpcap -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc	%tcpdump_dir/README %tcpdump_dir/CHANGES
%{_sbindir}/tcpdump
%{_sbindir}/tcpslice
%{_mandir}/man8/tcpslice.8*
%{_mandir}/man8/tcpdump.8*

%files -n libpcap
%defattr(-,root,root)
%doc	%libpcap_dir/README %libpcap_dir/CHANGES
%{_includedir}/*
%{_libdir}/libpcap.*
%{_mandir}/man3/pcap.3*

%files -n arpwatch
%defattr(-,root,root)
%doc	%arpwatch_dir/README %arpwatch_dir/CHANGES
%{_sbindir}/arpwatch
%{_sbindir}/arpsnmp
%{_mandir}/man8/arpwatch.8*
%{_mandir}/man8/arpsnmp.8*
%config	/etc/rc.d/init.d/arpwatch
%config(noreplace) /etc/sysconfig/arpwatch
%defattr(-,pcap,pcap)
%dir	%{_vararpwatch}
%config	%{_vararpwatch}/arp.dat
%config	%{_vararpwatch}/ethercodes.dat
%config	%{_vararpwatch}/missingcodes.txt
%{_vararpwatch}/*.awk
%{_vararpwatch}/arp2ethers
%{_vararpwatch}/arpfetch
%{_vararpwatch}/massagevendor
%{_vararpwatch}/massagevendor-old

%changelog
* Mon Jan 19 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 3.6.3, Release 1.0.6
  - Fix CAN-2003-0989 and CAN-2003-1029.

* Tue Apr 29 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 3.6.3, Release 1.0.5
  - Upgrade to the 3.6.3 package we have in Thrust and Feint.
  - Apply fixes for RADIUS, ISAKMP, and BGP issues.
